def forward (kara, n)
  for i in (0..n-1)
    if not kara.onLeaf
       kara.putLeaf
    end
    kara.move
  end
end

def replace (string, find, replace)
  result = ""
  index = 0

  while index <= string.length-find.length
    currentSubString = string[index..index+find.length-1]

    if currentSubString == find
      result += replace
      index  += find.length
    else
      result += currentSubString
      index += 1
    end
  end

  result
end

def interpret (tools, kara, string, stepLength)
  for i in (0..string.length-1)
    if string[i..i] == 'F'
      forward(kara, stepLength)
    elsif string[i..i] == 'L'
      kara.turnLeft
    elsif string[i..i] == 'R'
      kara.turnRight
    end
  end
end


GENERATOR_FIND = "F"
GENERATOR_REPLACE = "FLFRFRFLF"
ITERATIONS = 3

string = "FF"

for i in (0..ITERATIONS-1)
  world.clearAll
  kara.setPosition (0, world.getSizeY-1)
  interpret (tools, kara, string, 3)
  tools.sleep(500)
  string = replace (string, GENERATOR_FIND, GENERATOR_REPLACE)
end

world.clearAll
kara.setPosition (0, world.getSizeY-1)
interpret (tools, kara, string, 3)